// ContextCommon.h


#ifndef __CONTEXTCOMMON__
#define __CONTEXTCOMMON__

#include <e32base.h>


//--------------------- SERVER PANICS --------------------

//Panic Category
_LIT(KContextServer, "ContextServer");

//Panic Codes
enum TContextServPanic
{
	EBadRequest,
	EBadDescriptor,
	ESrvCreateServer,
    	ECreateTrapCleanup
};


//--------------------- SERVER PARAM --------------------

_LIT(KContextServerName,"myContextServer");
_LIT(KContextServerSemaphoreName, "AmyContextServerSemaphore");


//the server version. A version must be specified when 
//creating a session with the server
const TUint KContextServMajorVersionNumber=0;
const TUint KContextServMinorVersionNumber=1;
const TUint KContextServBuildVersionNumber=1;


//opcodes used in message passing between client and server
enum TContextServRqst
{
	ETerminateContextServer,
	EConnectToPresenceServer,
	EDisconnectFromPresenceServer,
	ERequestPresenceInfo,
	ERequestPresenceNotification,
	EUpdateUserPresence,
	ESuspendConnection,
	EResumeConnection,
		
	ECancel

};

//opcodes used by server to indicate which asynchronous service
//has completed
enum TContextServRqstComplete
{
	ERequestCompleted = 1,
	EIdentificationError = -1,
	EServerUnreachable = -2,
	EBufferTooSmall = -3,
	EContextServerTerminated = -4

	


};


#endif // __CONTEXTCOMMON__

