#if !defined(FILE_OUTPUT_BASE_H_INCLUDED)

#define FILE_OUTPUT_BASE_H_INCLUDED

#include <f32file.h>
#include <charconv.h>
#include <e32std.h>

#include "app_context.h"

class Mfile_output_base : public MContextBase {
public:
	IMPORT_C Mfile_output_base(MApp_context& Context);
	IMPORT_C virtual ~Mfile_output_base();
	IMPORT_C void ConstructL(const TDesC& prefix, bool do_open_file=true);
	IMPORT_C void switch_file() { open_file(*file_prefix); }
	IMPORT_C static const TLitC<3> nl;
	IMPORT_C void write_time();
	IMPORT_C void write_time(const TTime& time);
	IMPORT_C virtual void write_to_output(const TDesC& str);
	IMPORT_C virtual void write_to_output(const TDesC8& str);
	IMPORT_C static void make_filename(TDes& into_buffer, const TDesC& dir, const TDesC& prefix);
	IMPORT_C static void make_filename(TDes& into_buffer, const TDesC& dir, const TDesC& prefix, const TDesC& extension);
	IMPORT_C void write_nl();
protected:
	IMPORT_C void open_file(const TDesC& prefix);
	IMPORT_C void close_file();
private:
	RFile file;
	TBuf8<512> buf;
	HBufC* file_prefix;
	TInt state;
};

class Cfile_output_base: public Mfile_output_base, public CBase
{
public:
	IMPORT_C Cfile_output_base(MApp_context& Context);
	IMPORT_C virtual ~Cfile_output_base();
	IMPORT_C static Cfile_output_base* NewL(MApp_context& Context, const TDesC& prefix, bool do_open_file=true);
};

#endif
