#if !defined(INDEPENDENT_H_INCLUDED)

#define INDEPENDENT_H_INCLUDED

#include <e32std.h>

struct worker_info {
	TThreadId worker_threadid;
	TThreadId parent_threadid;
	TRequestStatus  *do_stop;
	TRequestStatus  is_stopped;
	TAny*	   worker_args;

	IMPORT_C void please_stop();
	IMPORT_C void stopped();
	IMPORT_C void wait_for_stop();
	IMPORT_C bool stop_requested();
	IMPORT_C void set_do_stop(TRequestStatus* s);

	IMPORT_C worker_info();
	IMPORT_C ~worker_info();
private:
	TRequestStatus  *i_do_stop;
};

class independent_worker {
public:
	IMPORT_C void start(const TDesC& name, TThreadFunction aFunction, TAny* worker_args);
	IMPORT_C void stop();
	IMPORT_C ~independent_worker();
	IMPORT_C independent_worker();
private:
	bool is_started;
	worker_info info;
};

#endif
