#ifndef CC_XML_H_INCLUDED
#define CC_XML_H_INCLUDED 1

#include "app_context.h"
#include "expat.h"
#include "list.h"

class MXmlHandler {
public:
	virtual void StartElement(const XML_Char *name,
				const XML_Char **atts) = 0;

	virtual void EndElement(const XML_Char *name) = 0;
	virtual void CharacterData(const XML_Char *s,
				    int len) = 0;
	virtual void Error(XML_Error Code, const XML_LChar * String, long ByteIndex) = 0;
};

class CXmlParser : public CBase {
public:
	static CXmlParser* NewL(MXmlHandler& Handler);
	void Parse(const char*, int len, int isFinal);
	~CXmlParser();
private:
	static void StartElement(void *userData,
				   const XML_Char *name,
				   const XML_Char **atts);

	static void EndElement(void *userData,
				 const XML_Char *name);
	static void CharacterData(void *userData,
				    const XML_Char *s,
				    int len);

	CXmlParser(MXmlHandler& Handler);
	void ConstructL();

	MXmlHandler&	iHandler;
	XML_Parser	iParser;
};

#endif
