#ifndef LIST_H_INCLUDED
#define LIST_H_INCLUDED 1

#include "pointer.h"

template<typename Data> class CList {
public:
	struct Node 
	{
		Data	Item;
		Node* Previous;
		Node(): Previous(0) { }
	};
	Node	*iLast;
	
	Node* AppendL(Data Item) 
	{
		Node* np=new (ELeave) Node;
		auto_ptr<Node> n(np);
		n->Item=Item;
		if (iLast) 
		{
			n->Previous=iLast;
		} 
		else 
		{
			n->Previous=NULL;
		}
		iLast = n.release();
		return iLast;
	}
	
	static CList* NewL() 
	{
		auto_ptr<CList> self(new (ELeave) CList);
		self->ConstructL();
		return self.release();
	}

	~CList() 
	{
		reset();
	}
	
	void reset() 
	{
		
		while (iLast!=0)
		{
			Node* tmp = iLast->Previous;
			delete iLast;
			iLast = tmp;
		}
	
		iLast=0;
	}
	
	void DeleteLast() 
	{
		if (!iLast) return;
		Node* tmp=iLast;
		iLast=tmp->Previous;
		delete tmp;
	}

private:
	CList() : iLast(0) { }
	void ConstructL() { }
};
#endif
