/*
* ============================================================================
*  Name     : CSettingsView from SettingsView.h
*  Part of  : Settings
*  Created  : 13.1.2004 by 
*  Description:
*     Declares view for application.
*  Version  :
*  Copyright: 
* ============================================================================
*/

#ifndef SETTINGSVIEW_H
#define SETTINGSVIEW_H

// INCLUDES
#include <aknview.h>

#ifndef NULL
#define NULL 0
#endif

#include <aknsettingitemlist.h>
#include "app_context.h"

// CONSTANTS
// UID of view
const TUid KSettingsViewId = {2};

/**
*  CSettingsView view class.
* 
*/

#ifndef NULL
#define NULL 0
#endif

class CCLSettingList: public CAknSettingItemList 
    {
    public:
        CAknSettingItem* CreateSettingItemL( TInt identifier );
	void SetListData();
	void UpdateJabberNick();
	void UpdateJabberPass();
	void UpdatePresence();
	void UpdatePictures();
	void UpdateUrlBase();
        TBuf<50>	iJabberNick;
        TBuf<50>	iJabberPass;
        TBuf<50>	iUrlBase;
	TInt		iWapIap;
	TInt		iIpIap;
	TInt		iPresence;
	TInt		iPictures;
    private:
	CAknEnumeratedTextPopupSettingItem *wap_list;
	CAknEnumeratedTextPopupSettingItem *ip_list;
	CAknEnumeratedTextPopupSettingItem *presence_list;
	CAknEnumeratedTextPopupSettingItem *picture_list;
	CAknTextSettingItem* jabbernick;
	CAknTextSettingItem* jabberpass;
	CAknTextSettingItem* urlbase;
    };

class CSettingsView : public CAknView, public MContextBase
    {
    public: // Constructors and destructor
	static CSettingsView* NewL(MApp_context& Context);

        /**
        * Destructor.
        */
        ~CSettingsView();

    public: // Functions from base classes
        
        /**
        * From ?base_class ?member_description
        */
        TUid Id() const;

        /**
        * From ?base_class ?member_description
        */
        void HandleCommandL(TInt aCommand);

        /**
        * From ?base_class ?member_description
        */
        void HandleClientRectChange();

    private:
	CSettingsView(MApp_context& Context);
        void ConstructL();

        /**
        * From AknView, ?member_description
        */
        void DoActivateL(const TVwsViewId& aPrevViewId,TUid aCustomMessageId,
            const TDesC8& aCustomMessage);

        /**
        * From AknView, ?member_description
        */
        void DoDeactivate();

    private: // Data
        CCLSettingList* iListBox;
    };

#endif

// End of File
