#ifndef CL_APPLOGVIEW_H_INCLUDED
#define CL_APPLOGVIEW_H_INCLUDED 1

#include <aknview.h>
#include <eiktxlbx.h>
#include "circular.h"
#include <aknglobalnote.h> 
#include <aknnotewrappers.h> 

const TUid KLogViewId = {3};

class CLogContainer : public CCoeControl, MCoeControlObserver, public MListObserver {
public: // Constructors and destructor
        
	CLogContainer();
        void ConstructL(const TRect& aRect, CCircularLog* Log, MEikListBoxObserver* ListBoxObserver);
	
        ~CLogContainer();
	void ContentsChanged();
	
private: // Functions from base classes
	
        void SizeChanged();
        TInt CountComponentControls() const;
        CCoeControl* ComponentControl(TInt aIndex) const;
        void Draw(const TRect& aRect) const;
        void HandleControlEventL(CCoeControl* aControl,TCoeEvent aEventType);
	TKeyResponse OfferKeyEventL(const TKeyEvent &aKeyEvent, TEventCode aType);
private: //data
        CEikTextListBox* iListBox;
	CCircularLog*	iLog;
};

class CAppLogView : public CAknView, public MEikListBoxObserver
{
public: // Constructors and destructor
	static CAppLogView* NewL(CCircularLog* Log);
        ~CAppLogView();
	
public: // Functions from base classes
        
        TUid Id() const;
	
        void HandleCommandL(TInt aCommand);
	
        void HandleClientRectChange();
	
private:
	CAppLogView();
        void ConstructL(CCircularLog* Log);
	
        void DoActivateL(const TVwsViewId& aPrevViewId,TUid aCustomMessageId,
		const TDesC8& aCustomMessage);
        void DoDeactivate();

	void HandleListBoxEventL(CEikListBox* aListBox,TListBoxEvent aEventType);
	
private: // Data
	CLogContainer*	iContainer;
	CCircularLog*	iLog;
};


#endif // CL_LOGVIEW_H_INCLUDED
