#ifndef CL_CIRCULAR_H_INCLUDED
#define CL_CIRCULAR_H_INCLUDED 1

#include "badesca.h"

class MListObserver {
public:
	virtual void ContentsChanged() = 0;
};

class CCircularLog : public MDesCArray, public CBase {
public:
	static CCircularLog* NewL(int Size, bool Reverse);
	void AddL(const TDesC& String);
	~CCircularLog();
	void SetObserver(MListObserver* Observer);

	// From MDesCArray
	virtual TInt MdcaCount() const;
	virtual TPtrC16 MdcaPoint(TInt aIndex) const;
private:
	CCircularLog(bool Reverse);
	void ConstructL(int Size);

	bool	iReverse;
	int	iSize;
	int	iPos;
	int	iCount;

	CDesCArrayFlat*	iArray;
	MListObserver*	iObserver;
};

#endif // CL_CIRCULAR_H_INCLUDED
