#if !defined(FILE_LOGGER_H_INCLUDED)

#define FILE_LOGGER_H_INCLUDED

#include "i_logger.h"
#include "i_log_source.h"
#include "file_output_base.h"

class Cfile_logger : public Mlogger, public Mfile_output_base, public CBase, public MPausable {
public:
	virtual void register_source(const TDesC& name, const TDesC& initial_value, const TTime& time);
	virtual void new_value(log_priority priority, const TDesC& name, const TDesC& value, const TTime& time);
	virtual void unregister_source(const TDesC& name, const TTime& time);
	virtual const TDesC& name() const;
	Cfile_logger(MApp_context& Context, log_priority limit=VALUE);
	virtual ~Cfile_logger();
	void ConstructL(const TDesC& prefix);
	static Cfile_logger* NewL(MApp_context& Context,
				 const TDesC& prefix, log_priority limit=VALUE);
	void pause();
	void unpause();
	bool is_paused();
private:
	virtual void write_to_output(const TDesC& str);

	log_priority priority_limit;

	bool paused;
};

#endif
