#ifndef CL_HTTP_H_INCLUDED
#define CL_HTTP_H_INCLUDED 1

#include "ver.h"
#include "ftp.h"

class CHttp : public CBase, public MContextBase, public MTimeOut, public MSocketObserver {
public:
	static CHttp* NewL(MApp_context& Context, MSocketObserver& obs);
	~CHttp();
	void Connect(TUint32 IapID, const TDesC& UrlBase);
	void Store(const TDesC& filename, const TDesC& meta=KNullDesC);
	void Close();
	void Cwd(const TDesC& dir);
private:
	CHttp(MApp_context& Context, MSocketObserver& obs);
	void ConstructL();
	MSocketObserver& observer;
	void HandleFile();

	// MSocketObserver
	virtual void success(CBase* source);
	virtual void error(CBase* source, TInt code, const TDesC& reason);
	virtual void info(CBase* source, const TDesC& msg);

	void expired();

	enum state { IDLE, CONNECTING, CONNECTING_SOCKET, HEAD_TX, BODY_TX, CONNECTED, RESULT_OK_WAIT };
	state current_state;


	TUint32		iIapId;
	CConnectionOpener *iInitiator;
	RSocketServ	iOwnedServ;
#ifdef __S60V2__
	RConnection	iOwnedConnection;
#endif
	CProtoSocket*	iSocket;

	RFile		file;
	RFile		input;
	TBuf<256>	iPath;
	TBuf<128>	iHost;

	TInetAddr	iAddr; bool iAddrKnown;

	TBuf<40>	iState;
	TFileName	iFilename;
	HBufC8*		iContents;
	HBufC*		iURL;
	TBuf8<500>	head;
	TInt		iFileSize;
	TInt		iOffset;
	TInt		iRetryCount;
	static const TInt	MAX_RETRIES;
	TInt	MAXSIZE;
	CTimeOut	*iWait;
	TBuf<200>	iMeta;
};


#endif
