#if !defined(LOG_CELLID_H_INCLUDED)

#define LOG_CELLID_H_INCLUDED

#include "i_log_source.h"
#include "log_base_impl.h"

#include <e32base.h>
#include <etelbgsm.h>

#include "app_context.h"
#include "cellmap.h"

#ifdef __WINS__
#include "bases.h"
#endif

class Clog_cellid: public CCheckedActive, public Mlog_base_impl
{
public:
	~Clog_cellid();
	
	const TDesC& get_value();
	
	static Clog_cellid* NewL(MApp_context& Context, CCellMap& CellMap);
	bool call_in_progress();

private:
	virtual void DoCancel();
	virtual void CheckedRunL(); 
	virtual TInt CheckedRunError(TInt aError);
private:
	Clog_cellid(MApp_context& Context, CCellMap& CellMap);
	void ConstructL();
	
	HBufC* cellid_value;
	RLine line;
	MBasicGsmPhoneNetwork::TCurrentNetworkInfo async_info;
	MBasicGsmPhoneNetwork::TCurrentNetworkInfo prev_info;

	TInt	iErrorCount;
#ifdef __WINS__
	int test_data_i;
	RTimer timer;
#endif
};

#endif
