#if !defined(LOG_PROFILE_H_INCLUDED)

#define LOG_PROFILE_H_INCLUDED

#include "i_log_source.h"
#include "log_base_impl.h"
#include <profileapi.h>
#include <saclient.h>
#include "app_context.h"
#include "timeout.h"

class Clog_profile : public CCheckedActive, public Mlog_base_impl, public MTimeOut{
public:
	~Clog_profile();

	const TDesC& get_value();

	void CheckedRunL();

	static Clog_profile* NewL(MApp_context& Context);
	void DoCancel();
	virtual TInt CheckedRunError(TInt aError);
	int get_current_profile() { return prev_profile; }

private:
	void expired() { }
	IMPORT_C void expired(CBase* Source);

	Clog_profile(MApp_context& Context);
	void ConstructL();

	HBufC* profile_value;
	HBufC* name;
	int prev_profile, iProfileUid;
	TInt iRingingType, iRingingVolume;
	TBool iVibra;
	CArrayFixFlat<TSysAgentCondition>* aConditions;
	TInt get_profile_via_profilapi();
	TBuf<10> iVibraDescr;
	void listen_for_notification();
	CTimeOut *iWait;
};

#endif
