#if !defined(MDA_RECORDER_H_INCLUDED)

#define MDA_RECORDER_H_INCLUDED 1

#include <e32base.h>

#define NULL 0
#include <MdaAudioSampleEditor.h>
#include <f32file.h>
#include "app_context.h"
#include "riff.h"
#include <mda/Common/GsmAudio.h>
#include <AmrMda.h>

class Mrecorder_callback {
public:
	virtual void stopped(bool reset=false) = 0;
	virtual void error(const TDesC& descr) = 0;
	virtual void opened() = 0;
};

class CMda_recorder : public CTimer, public MMdaObjectStateChangeObserver, public MContextBase {
public:
	virtual ~CMda_recorder();

	static CMda_recorder* NewL(MApp_context& Context, Mrecorder_callback* i_cb, TInt channels, TInt freq, TInt seconds);
	virtual void MoscoStateChangeEvent(CBase* aObject, TInt aPreviousState, TInt aCurrentState, TInt aErrorCode);

	//virtual void record();
	virtual void record(const TDesC& filename);
	void save(const TDesC& filename);
	bool IsIdle() { return current_state==IDLE; }

protected:
	void ConstructL(Mrecorder_callback* i_cb, TInt channels, TInt freq, TInt seconds);
	//HBufC8*	buf; TPtr8 bufdes;
	CMda_recorder(MApp_context& Context);
	void open();
	void RunL();
private:
	Mrecorder_callback* cb;
	void do_record();

	enum state { IDLE, OPENING, STARTING_RECORD, RECORDING, STOPPING };
	state current_state;


	TMdaRawAmrClipFormat format;
	TMdaRawAmrAudioCodec* codec; 
	TMdaAudioDataSettings args;
	//TMdaDesClipLocation *clip;
	TMdaFileClipLocation *clip;

	CMdaServer* audio_server;
	CMdaAudioRecorderUtility* recorder_util;

	TBuf<100> msg;
	int rec_seconds;
	int rec_freq;
	int rec_channels;
};

#endif
