#if !defined(RECORDER_H_INCLUDED)


#define RECORDER_H_INCLUDED 1

#include <e32base.h>
#include <MdaAudioInputStream.h>
#include <mda/common/audio.h>
#include <f32file.h>
#include "app_context.h"
#include "riff.h"


class Mrecorder : public MMdaAudioInputStreamCallback {
public:
	virtual ~Mrecorder();

	const TDesC& get_value();

	void CheckedRunL();

	static Mrecorder* NewL();
	void  MaiscOpenComplete (TInt aError);
	void  MaiscBufferCopied (TInt aError, const TDesC8 &aBuffer);
	void  MaiscRecordComplete (TInt aError);	

	virtual void stopped(bool reset=false) = 0;
	virtual void error(const TDesC& descr) = 0;
	virtual void opened() = 0;
	virtual void record();
	void save(const TDesC& filename);

protected:
	void ConstructL(TInt channels, TInt freq, TInt seconds);
	HBufC8*	buf; TPtr8 bufdes;
	Mrecorder();
	void open();
private:
	CMdaAudioInputStream* istream;

	TMdaWavClipFormat format;
	TMdaPcmWavCodec codec; 
	TMdaAudioDataSettings args;
	TMdaFileClipLocation audio_loc;

	TBuf<100> msg;
	int rec_seconds;
	int rec_freq;
	int rec_channels;
};

#endif