#ifndef USER_VIEW_H_INCLUDED
#define USER_VIEW_H_INCLUDED 1

#include <aknview.h>
#include <eiktxlbx.h>
#include "circular.h"
#include "doublelinebox.h"

const TUid KUserViewId = {4};

class CUserContextContainer : public CCoeControl, MCoeControlObserver, public MListObserver {
public: // Constructors and destructor
        
	CUserContextContainer();
        void ConstructL(const TRect& aRect, CCircularLog* Log, MEikListBoxObserver* ListBoxObserver);
	
        ~CUserContextContainer();
	void ContentsChanged();
	
private: // Functions from base classes
	
        void SizeChanged();
        TInt CountComponentControls() const;
        CCoeControl* ComponentControl(TInt aIndex) const;
        void Draw(const TRect& aRect) const;
        void HandleControlEventL(CCoeControl* aControl,TCoeEvent aEventType);
		TKeyResponse OfferKeyEventL(const TKeyEvent &aKeyEvent, TEventCode aType);
private: //data
        //CEikTextListBox* iListBox;
		CEikFormattedCellListBox * iListBox;
		CCircularLog*	iLog;
	
		
};

class CUserView : public CAknView, public MEikListBoxObserver
{
public: // Constructors and destructor
	static CUserView* NewL(CCircularLog* Log);
        ~CUserView();
	
public: // Functions from base classes
        
        TUid Id() const;
	
        void HandleCommandL(TInt aCommand);
	
        void HandleClientRectChange();
	
private:
		CUserView();
        void ConstructL(CCircularLog* Log);
	
        void DoActivateL(const TVwsViewId& aPrevViewId,
						TUid aCustomMessageId,
						const TDesC8& aCustomMessage);
        void DoDeactivate();

		void HandleListBoxEventL(CEikListBox* aListBox,TListBoxEvent aEventType);
	
private: // Data
	CUserContextContainer*	iContainer;
	CCircularLog*	iLog;
	
};


#endif // USER_VIEW_H_INCLUDED
