#ifndef CL_WEB_H_INCLUDED
#define CL_WEB_H_INCLUDED 1

#include <aknform.h>
#include "db.h"
#include "ftp.h"
#include "log_base_impl.h"

class CSavedPoints : public MDBStore, public MContextBase, public CBase {
public:
	enum TEndPoint { FROM=0, TO=1 };

	static CSavedPoints* NewL(MApp_context& Context, RDbStoreDatabase& Db);
	const CDesCArray& Points(TEndPoint p) const;
	void AddPoint(TEndPoint p, const TDesC& Point);
	void IncUsage(TEndPoint p, TInt PointIdx);

	virtual ~CSavedPoints();
private:
	CSavedPoints(MApp_context& Context, RDbStoreDatabase& Db);
	void ConstructL();

	CDesCArray*		iPoints[2];
	CArrayFixFlat<TInt>*	iIdxs[2];
	TInt			iNextIdx;
};

class CWebForm : public CAknForm, public MContextBase
{
public:
        static CWebForm* NewL(MApp_context& Context, CConnectionOpener& Opener, Mlog_base_impl& Log);
	
        virtual ~CWebForm();
	
        TInt ExecuteLD(); 
        void PrepareLC(); 
	
private:  // Constructor
        CWebForm(MApp_context& Context, CConnectionOpener& Opener, Mlog_base_impl& Log);
        void ConstructL();
	
private:  // Functions from base class
        void PostLayoutDynInitL();
        TBool QuerySaveChangesL();
        TBool SaveFormDataL(); 
        void DoNotSaveFormDataL();
	virtual TBool OkToExitL( TInt aButtonId ) ;

	TInt  GetCurrentItem(TInt Id);

	CSavedPoints*	iPoints;
	CDb*		iDb;
	bool		iSaved[2];
	TInt		iLastKey;

	CConnectionOpener& iOpener;
	Mlog_base_impl& iLog;
};

#endif
