#include "doublelinebox.h"

#include <eikfrlbd.h> 

#include "app_context.h"

drawer::drawer(MTextListBoxModel *aTextListBoxModel, const CFont *aFont, CFormattedCellListBoxData *aFormattedCellData) :
		CFormattedCellListBoxItemDrawer(aTextListBoxModel, aFont, aFormattedCellData)
		{
			itemd=aFormattedCellData;
			iTextListBoxModel=aTextListBoxModel;
			
		}


void drawer::DrawItemText (TInt aItemIndex, const TRect &aItemTextRect, 
		TBool aItemIsCurrent, TBool aViewIsEmphasized, TBool aItemIsSelected) const 
{
	CALLSTACKITEM(_L("drawer::DrawItemText"));

		
		/*TPtrC p = TPtrC( iTextListBoxModel->ItemText(aItemIndex) ); 
		
		if ( grey )
		{
			CFormattedCellListBoxData::TColors c = itemd->SubCellColors(1);
			
			
			c.iText = TRgb(128,128,128);
			c.iHighlightedText = TRgb(128,128,128);
			
			c.iBack = TRgb(255,255,255);
			c.iHighlightedBack = TRgb(220,220,220);
		
			//itemd->SetSubCellColorsL(0, c);
			itemd->SetSubCellColorsL(1, c);
			itemd->SetSubCellColorsL(2, c);
			itemd->SetSubCellColorsL(3, c);
			itemd->SetSubCellColorsL(4, c);

			CFormattedCellListBoxData::TColors c2 = itemd->SubCellColors(1);
			c2.iText = TRgb(0,0,0);
			c2.iHighlightedText = TRgb(0,0,0);
			
			c2.iBack = TRgb(255,255,255);
			c2.iHighlightedBack = TRgb(220,220,220);
			itemd->SetSubCellColorsL(0, c2);

		}
		else
		{
			
			CFormattedCellListBoxData::TColors c = itemd->SubCellColors(1);
			
			c.iText = TRgb(0,0,0);
			c.iHighlightedText = TRgb(0,0,0);

			c.iBack = TRgb(255,255,255);	
			c.iHighlightedBack = TRgb(170,170,255);

			//itemd->SetSubCellColorsL(0, c);
			itemd->SetSubCellColorsL(1, c);
			itemd->SetSubCellColorsL(2, c);
			itemd->SetSubCellColorsL(3, c);
			itemd->SetSubCellColorsL(4, c);

			CFormattedCellListBoxData::TColors c2 = itemd->SubCellColors(1);
			c2.iText = TRgb(0,0,0);
			c2.iHighlightedText = TRgb(0,0,0);
			
			c2.iBack = TRgb(255,255,255);
			c2.iHighlightedBack = TRgb(170,170,255);
			itemd->SetSubCellColorsL(0, c2);
		}
		*/
		CFormattedCellListBoxItemDrawer::DrawItemText(aItemIndex, aItemTextRect,
			aItemIsCurrent, aViewIsEmphasized, aItemIsSelected);
	}
	
doublelinebox::doublelinebox() : CEikFormattedCellListBox()
{
	CALLSTACKITEM(_L("doublelinebox::doublelinebox"));

}


void doublelinebox::CreateItemDrawerL(void)
{
	CALLSTACKITEM(_L("doublelinebox::CreateItemDrawerL"));

	CFormattedCellListBoxData* itemd=CFormattedCellListBoxData::NewL();

	CleanupStack::PushL(itemd);

	TMargins marg;
	TMargins marg_image;
	marg.iBottom=marg.iTop=marg_image.iBottom=marg_image.iTop=marg_image.iLeft=marg_image.iRight=0;
	marg.iLeft= 2;
	marg.iRight=0;

	//Name of contact
	itemd->SetSubCellMarginsL(0, marg);		
	itemd->SetSubCellSizeL(0, TSize(116, 20) );
	itemd->SetSubCellPositionL(0, TPoint(18, 0) );
	itemd->SetSubCellBaselinePosL(0, 16);
	itemd->SetSubCellFontL(0, iEikonEnv->DenseFont() );
	itemd->SetSubCellAlignmentL(0, CGraphicsContext::ELeft);
	
	//Textual PresenceInfo
	itemd->SetSubCellMarginsL(1, marg);
	itemd->SetSubCellSizeL(1, TSize(178, 20) );
	itemd->SetSubCellPositionL(1, TPoint(0, 20) );
	itemd->SetSubCellBaselinePosL(1, 32);
	itemd->SetSubCellFontL(1, iEikonEnv->DenseFont() );
	itemd->SetSubCellAlignmentL(1, CGraphicsContext::ELeft);

	// Contact Icon (type of number)
	itemd->SetSubCellMarginsL(2, marg_image);
	itemd->SetSubCellSizeL(2, TSize(18, 20) );
	itemd->SetSubCellPositionL(2, TPoint(0, 0) );
	itemd->SetSubCellBaselinePosL(2, 16);
	itemd->SetSubCellFontL(2, iEikonEnv->DenseFont() );
	itemd->SetGraphicsSubCellL(2,ETrue);
	itemd->SetSubCellAlignmentL(2, CGraphicsContext::ECenter);

	// Ringing volume
	itemd->SetSubCellMarginsL(3, marg_image);
	itemd->SetSubCellSizeL(3, TSize(18, 20) );
	itemd->SetSubCellPositionL(3, TPoint(134, 0) );
	itemd->SetSubCellBaselinePosL(3, 16);
	itemd->SetSubCellFontL(3, iEikonEnv->DenseFont() );
	itemd->SetSubCellAlignmentL(3, CGraphicsContext::ECenter);
	itemd->SetGraphicsSubCellL(3,ETrue);

	// Vibrator
	itemd->SetSubCellMarginsL(4, marg_image);
	itemd->SetSubCellSizeL(4, TSize(28, 20) );
	itemd->SetSubCellPositionL(4, TPoint(150, 0) );
	itemd->SetSubCellBaselinePosL(4, 16);
	itemd->SetSubCellFontL(4, iEikonEnv->DenseFont() );
	itemd->SetSubCellAlignmentL(4, CGraphicsContext::ECenter);
	itemd->SetGraphicsSubCellL(4,ETrue);

	//iItemDrawer=new (ELeave) CFormattedCellListBoxItemDrawer(Model(), iEikonEnv->NormalFont(), itemd);
	iItemDrawer=new (ELeave) drawer(Model(), iEikonEnv->NormalFont(), itemd);

	CleanupStack::Pop();
	
}

doublelinebox::~doublelinebox()
{
	CALLSTACKITEM(_L("doublelinebox::~doublelinebox"));

}

