/*
* ============================================================================
*  Name     : CContextbookContainer from ContextbookContainer.h
*  Part of  : contextbook
*  Created  : 14.7.2003 by 
*  Description:
*     Declares container control for application.
*  Version  :
*  Copyright: 
* ============================================================================
*/

#ifndef CONTEXTBOOKCONTAINER_H
#define CONTEXTBOOKCONTAINER_H

// INCLUDES
#include <coecntrl.h>
#include <aknlists.h>
#include <cntitem.h>
#include <e32base.h>
#include <CPbkContactEngine.h>
#include <eikedwin.h>
#include <sendui.h>
#include <aknglobalnote.h>
#include <cpbkcontactengine.h> 

#include "phonehelper.h"
#include "phonebook.h"

#include "file_output_base.h"

// FORWARD DECLARATIONS
class CEikLabel;        // for example labels

const TInt KIconOffset = 14;

/*enum Icons
   {
      IconEmpty=0,
      IconUserActive,
      IconUserInactive_lvl1,
	  IconUserInactive_lvl2,
	  IconUserInactive_lvl3,
	  IconSpeakerOn,
	  IconSpeakerOff,
	  IconVibratorOn,
	  IconVibretorOff,
	  IconSpeakerOnGrey,
	  IconSpeakerOffGrey,
	  IconVibratorOnGrey,
	  IconVibratorOffGrey
   };
*/






class CContextbookContainer : public CCoeControl, MCoeControlObserver, MEikListBoxObserver, MEikEdwinObserver, public phonebook_observer
{
public: // Constructors and destructor
        
        /**
        * EPOC default constructor.
        * @param aRect Frame rectangle for container.
        */
        void ConstructL(const TRect& aRect, phonebook_i* i_book, bool i_searchable, const TDesC& title, Cfile_output_base * aLog);
	
        /**
        * Destructor.
        */
        ~CContextbookContainer();
	
public: // New functions
	void call_current();
	void sms_current();
	TInt get_current_idx();
	
	void filter();
public: // Functions from base classes

	// phonebook_observer
	void contents_changed();	
	void before_change();

	void exiting();
private: // Functions from base classes
	
	 /**
	 * From CoeControl,SizeChanged.
        */
        void SizeChanged();
	
	/**
        * From CoeControl,CountComponentControls.
        */
        TInt CountComponentControls() const;
	
	/**
        * From CCoeControl,ComponentControl.
        */
        CCoeControl* ComponentControl(TInt aIndex) const;
	
	/**
        * From CCoeControl,Draw.
        */
        void Draw(const TRect& aRect) const;
	
	/**
        * From ?base_class ?member_description
        */
        // event handling section
        // e.g Listbox events
        void HandleControlEventL(CCoeControl* aControl,TCoeEvent aEventType);
	
        void HandleListBoxEventL(CEikListBox* aListBox,TListBoxEvent aEventType);
	
        TKeyResponse OfferKeyEventL(const TKeyEvent &, TEventCode);
	
	void HandleEdwinEventL(CEikEdwin* aEdwin,TEdwinEvent aEventType);

	virtual bool is_searchable() const; // whether to include the search box
	
	void  SetArrayIcons(CArrayPtr<CGulIcon> * icons, TIconList * list);

private: //data
        
    CEikFormattedCellListBox* listbox;
	CEikEdwin * edit;
	CArrayFixFlat<TInt>* resource_files;
	phonehelper* phone;
	phonebook_i* book;
	CSendAppUi* sendui;
	CAknGlobalNote* globalNote;
	CPbkContactEngine* pbkengine;
	bool owns_engine;
	bool searchable;
	
	TInt	iCurrentContactId;

	Cfile_output_base * iLog;

	

	
};

#endif

// End of File
