/*
* ============================================================================
*  Name     : CContextbookView from ContextbookView.h
*  Part of  : contextbook
*  Created  : 14.7.2003 by 
*  Description:
*     Declares view for application.
*  Version  :
*  Copyright: 
* ============================================================================
*/

#ifndef CONTEXTBOOKVIEW_H
#define CONTEXTBOOKVIEW_H

// INCLUDES
#include <aknview.h>
#include "phonebook.h"
#include "jabberdata.h"
#include "file_output_base.h"


// CONSTANTS
// UID of view
const TUid KViewId = {1};
const TUid KView2Id = {2};

// FORWARD DECLARATIONS
class CContextbookContainer;

// CLASS DECLARATION

/**
*  CContextbookView view class.
* 
*/
class CContextbookView : public CAknView
    {
    public: // Constructors and destructor

	    CContextbookView(CJabberData& JabberData, Cfile_output_base * aLog) : iJabberData(JabberData), iLog(aLog) { }
        void ConstructL(TUid i_id, phonebook_i* i_book, bool i_searchable, const TDesC& i_title);

	TInt GetCurrentIdx();
        /**
        * Destructor.
        */
        ~CContextbookView();

	
    public: // Functions from base classes
        
        /**
        * From ?base_class ?member_description
        */
        TUid Id() const;

        /**
        * From ?base_class ?member_description
        */
        void HandleCommandL(TInt aCommand);

        /**
        * From ?base_class ?member_description
        */
        void HandleClientRectChange();




    private:

        /**
        * From AknView, ?member_description
        */
        void DoActivateL(const TVwsViewId& aPrevViewId,TUid aCustomMessageId,
            const TDesC8& aCustomMessage);

        /**
        * From AknView, ?member_description
        */
        void DoDeactivate();

	virtual CContextbookContainer* create_container();
	void set_nick();
	void ShowEditor();

    private: // Data
        CContextbookContainer* iContainer;
	TUid id;
	phonebook_i* book;
	bool searchable;
	TBuf<50> title;
	CJabberData& iJabberData;

	Cfile_output_base * iLog;



    };

#endif

// End of File
