#ifndef CB_CALL_LOG_H_INCLUDED
#define CB_CALL_LOG_H_INCLUDED

#include "phonebook.h"
#include <logview.h>
#include <logcli.h>
#include "symbian_tree.h"



class call_log: public phonebook_i, public CCheckedActive {
public:
	call_log();
	virtual ~call_log();
	void ConstructL();
	
	MDesCArray* get_array();
	TIconList * get_iconlist();
	bool filter(const TDesC& substr, bool force=false);
	TPtrC get_phone_no(TInt index);
	virtual void set_observer(phonebook_observer* i_obs);
	virtual CPbkContactEngine* get_engine() { return eng; }
	virtual TInt GetContactId(TInt /*Index*/) { return KErrNotFound; }
	virtual TInt GetIndex(TInt /*ContactId*/) { return KErrNotFound; }
	virtual CArrayFixFlat<contact*>* GetContacts() { return NULL; }

	void CheckedRunL();
	void DoCancel();

	void refresh();
private:
	bool handle_event(const CLogEvent& ev);
	void copy_new_to_current();
	void ReRead();
private:	
	enum state { IDLE, WAITING_SET, WAITING_NEXT };
	state current_state;
	CPbkContactEngine *eng;
	bool owns_engine;
	phonebook_observer* obs;
	CPtrCArray* current_array;
	CPtrCArray* current_nos;

	CLogViewRecent* recent;
	CLogClient* logclient;
	CLogFilter* logfilter;

	CDesCArray* all_array;
	CDesCArray* all_nos;
	TLogId last_seen_id;
	bool getting_first;
	TInt new_from;


	//icon array
	TIconList * iconList;
	CGenericIntMap* iContactToItems;

	bool do_refresh; // redo refresh after current

};

#endif
